/*****************************************************************
** Editatab.c                                                   **
**                                                              **
** Para el programa: El Juego de la vida                        **
** Por: Miguel Angel Pizana Lopez                               **
** Fecha:01/Oct/99						**
**                                                              **
** Rutinas de Edicion de la tabla del juego de la vida          **
** Archivo Principal: vida.c                                    **
**                                                              **
** 26/sep/2007: Adecuado para compilar en GNU/linux/gcc         **
**								**
******************************************************************/


#include <stdio.h>
#include <ncurses.h>

#include "vida.h"
#include "terminal.h"
#include "editatab.h"


/* Rutina interfaz de usuario para editar tabla
   Debe regresar 0 cuando el usuario quiere salir del programa y
   distinto de 0 si desea continuar                              */
int EditarTabla(char Tabla[NumRen][NumCol]){
    int RenPos=0,ColPos=0,tecla;

    clear();
    ImpMensEdit();
    DibujaTabla(Tabla);
    PonCursor();

    cbreak(); /*cambia el comportamiento del getch, ver lib ncurses*/


    do{
      move(RenPos+1,ColPos+1);
      switch(tecla=getch()){
        case KEY_UP:RenPos--;break;
	case KEY_DOWN:RenPos++;break;
	case KEY_LEFT:ColPos--;break;
	case KEY_RIGHT:ColPos++;break;
	case 'x':
	case 'X': Tabla[RenPos][ColPos++]='X';addch('X');break;
	case ' ': Tabla[RenPos][ColPos++]=' ';addch(' ');break;
	case KEY__ENTER:
	case KEY_ESC:break;
	default: ;
      }
      if(RenPos>=NumRen)RenPos=NumRen-1;
      if(ColPos>=NumCol)ColPos=NumCol-1;
      if(RenPos<0)RenPos=0;
      if(ColPos<0)ColPos=0;
      refresh();
    }while(tecla != KEY__ENTER && tecla!=KEY_ESC);
    return(tecla!=KEY_ESC);
}
