/*****************************************************************
** Terminal.c                                                   **
**                                                              **
** Para el programa: El Juego de la vida                        **
** Por: Miguel Angel Pizana Lopez                               **
** Fecha:01/Oct/99						**
**                                                              **
** Rutinas de manejo de pantalla y teclado 			**
** para el juego de la vida       	       			**
** Archivo Principal: vida.c                                    **
**                                                              **
** 26/sep/2007: Adecuado para compilar en GNU/linux/gcc         **
**                                                              **
******************************************************************/

#include <stdio.h>
#include <ncurses.h>

#include "vida.h"
#include "terminal.h"

void InicializaTerminal(){
    initscr();
    noecho();
    cbreak();
    keypad(stdscr,TRUE);
    nodelay(stdscr, TRUE);
    clear();
    refresh();
}

void RestauraTerminal(){
    nocbreak();
    endwin();
}

void PonCursor(void){curs_set(2);/* 2 = muy visible*/}
void QuitaCursor(void){curs_set(0);/* 0 = invisible*/}

void DibujaTabla(char Tabla[NumRen][NumCol]){
    /*RenPos y ColPos son coordenadas de la tabla
      NO coordenadas de pantalla                 */
    int xPant,RenPos=0,ColPos=0;
    move(0,0);
    for(xPant=0;xPant<NumCol+2;xPant++)addch('#');
    for(RenPos=0;RenPos<NumRen;RenPos++){
      move(RenPos+1,0);
      addch('#');
      for(ColPos=0;ColPos<NumCol;ColPos++){
        addch(Tabla[RenPos][ColPos]);
      }
      addch('#');
    }
    move(NumRen+1,0);
    for(xPant=0;xPant<NumCol+2;xPant++)addch('#');
    refresh();
}

/*Mensaje de instrucciones al usuario del modo de edicion*/
void ImpMensEdit(void){
/*                        0         1         2         3
                          0123456789012345678901234567890 */
    mvprintw(0,NumCol+2, " El Juego de la Vida");
    mvprintw(2,NumCol+2, "      *** Edición ***");
    mvprintw(4,NumCol+2, " Uso del teclado: ");
    mvprintw(5,NumCol+2, "   Flechas:   Moverse");
    mvprintw(6,NumCol+2, "   Tecla 'X': Agregar un Ser");
    mvprintw(7,NumCol+2, "   Espacio:   Borrar un Ser");
    mvprintw(9,NumCol+2, "   Enter: Evolucionar");
    mvprintw(10,NumCol+2,"   Esc:   Salir");
}

/*Mensaje de instrucciones al usuario del modo de evolucion*/
void ImpMensEvol(void){
    mvprintw(0,NumCol+2," El Juego de la Vida");
    mvprintw(2,NumCol+2,"      *** Evolución ***");
    mvprintw(4,NumCol+2," Oprima 'Esc' para Editar");
}



