/*****************************************************************
** Vida.c (Archivo principal)                                   **
**								**
** El Juego de la vida                                          **
** Por: Miguel Angel Pizana Lopez                               **
** Fecha:01/Oct/99						**
**                                                              **
** Programa ejemplo para la materia de "Programacion Avanzada"  **
** Para ilustrar el disenio descendente y                       **
** los principios generales de la buena programacion            **
**                                                              **
** Componentes:                                                 **
**    Editatab.c                                                **
**    Terminal.c                                                **
**                                                              **
** 26/sep/2007: Adecuado para compilar en GNU/linux/gcc         **
**                                                              **
******************************************************************/

#include <stdio.h>
#include <ncurses.h>

#include "vida.h"
#include "terminal.h"
#include "editatab.h"

/*El programa tiene dos modos de funcionamiento:
	Edicion y Evolucion */

int main(){
    char Tabla[NumRen][NumCol];

    InicializaTerminal();
    InicializaTabla(Tabla);
    while(EditarTabla(Tabla))
      Evolucionar(Tabla);
    RestauraTerminal();
    return 0;
}

void InicializaTabla(char Tabla[NumRen][NumCol]){
    int Ren,Col;

    for(Ren=0;Ren<NumRen;Ren++){
      for(Col=0;Col<NumCol;Col++){
        Tabla[Ren][Col]=' ';
      }
    }
}

/* Aplica las leyes de la vida sobre tabla
   hasta que el usuario teclea 'ESC'*/
void Evolucionar(char Tabla[NumRen][NumCol]){
    char TablaVieja[NumRen][NumCol];
    int Ren,Col;

    clear();
    ImpMensEvol(); /*Imprime Instrucciones para el usuario*/
    QuitaCursor();
    DibujaTabla(Tabla);
    halfdelay(10); /*cambia el comportamiento de getch, ver lib. ncurses */


    /* 'HayX' regresa 1 si hay una X en la casilla dada y
    0 si no hay o la casilla especificada es invalida */
    #define HayX(ren,col) \
      ( (ren>=0 && ren<NumRen && \
         col>=0 && col<NumCol    ) ? TablaVieja[ren][col]=='X': 0 )

    /* 'Vecinos' cuenta el numero de 'X' que se encuentran en las
    casillas vecinas de la casilla dada en TablaVieja*/
    #define Vecinos(ren,col) \
        ( HayX(ren-1,col-1)+HayX(ren-1,col)+HayX(ren-1,col+1)+\
          HayX(ren  ,col-1)+                HayX(ren  ,col+1)+\
          HayX(ren+1,col-1)+HayX(ren+1,col)+HayX(ren+1,col+1)  )


    while(getch()!=KEY_ESC){
      for(Ren=0;Ren<NumRen;Ren++){
        for(Col=0;Col<NumCol;Col++){
	  TablaVieja[Ren][Col]=Tabla[Ren][Col];
	}
      }
      /* A continuacion estan codificadas
         las reglas del juego de la vida*/
      for(Ren=0;Ren<NumRen;Ren++){
        for(Col=0;Col<NumCol;Col++){
          if (TablaVieja[Ren][Col]=='X'){
	    switch(Vecinos(Ren,Col)){
	      case 2:
	      case 3:  Tabla[Ren][Col]='X';break;
	      default: Tabla[Ren][Col]=' ';break;
	    }
	  }else{
	    switch(Vecinos(Ren,Col)){
	      case 3:  Tabla[Ren][Col]='X';break;
	      default: Tabla[Ren][Col]=' ';break;
	    }
          }
        }
      }
      DibujaTabla(Tabla); /*DibujaTabla, ya incluye un "refresh()"*/
    } /*while*/

    /* 'HayX' y 'Vecinos' son para uso exclusivo de 'Evolucionar'*/
    #undef HayX
    #undef Vecinos
}
